#include "monitor.h"

unsigned char *videoram = (unsigned char*) 0xb8000;



void clearScreen()
{
	cursor_x = 0;
	cursor_y = 0;		

	int i;
	for (i = 0; i< 80*25*2; i=i+2)
	{
		videoram[i] = 0x20;
		videoram[i+1] = 0xF0;
	}

	updateCursorPosition();

}

void updateCursorPosition()
{
	uint16 cursorLocation = cursor_y * 80 + cursor_x;
	putByte(0x3D4,14);
	putByte(0x3D5,cursorLocation >> 8);
	putByte(0x3D4,15);
	putByte(0x3D5,cursorLocation);
}

void writech(char c)
{
	uint8 bgc = 0;
	uint8 fgc = 15;

	uint8 attributeByte = (bgc << 4) | (fgc & 0x0F);

	uint16 attribute = attributeByte << 8;
	uint16 *location;

	if (c == 0x08 && cursor_x)
	{
		cursor_x--;
	}

	else if (c==0x09)
	{
		cursor_x = (cursor_x+8) & ~(8-1);
	}

	else if (c=='\r')
	{
		cursor_x = 0;
	}
	
	 else if (c == '\n')
   	{
       		cursor_x = 0;
       		cursor_y++;
  	}

	else if(c >= ' ')
   	{
      	 	location = videoram + (cursor_y*80 + cursor_x);
       		*location = c | attribute;
       		cursor_x++;
   	}

	if (cursor_x >= 80)
  	{
       		cursor_x = 0;
       		cursor_y ++;
   	}

	updateCursorPosition();
}

void write(char *c)
{
	int i = 0;
	while(c[i])
	{
		writech(c[i++]);
	}
}
	
